include 'BIOS.inc'
include 'Vram.inc'
include 'Chars.inc'

ext SpritePattern

Top equ -1+24+16
Left equ 48

SpriteCount equ 25*2
unitSize equ 3
invaldY equ 192

    dseg
Sprites_:   public Sprites_
Buffer:
    defs unitSize*SpriteCount
FirstIndex:
    defs 1
FirstAddress:
    defs 2

; void InitSprites();
cseg
InitSprites_: public InitSprites_
	push	af
	push	hl
	push	de
	push	bc
        ld hl,Buffer
        ld de,unitSize
        ld b,SpriteCount
        do 
            ld (hl),invaldY
            add hl,de
        dwnz
        xor a
        ld (FirstIndex),a
        ld hl,Buffer
        ld (FirstAddress),hl
    pop	bc
	pop	de
	pop	hl
	pop	af
ret

cseg
ShowSprite_: public ShowSprite_
	push af | push hl | push de
        push de
            ld l,(ix+2)  ; index
            ld h,0
            ld e,l
            ld d,h
            add hl,hl   ;*2
            add hl,de   ;*3
            add hl,hl   ;*6
            ld de,Buffer
            add hl,de
        pop de
        di
            ld a,(ix+1) ; y
            add a,Top
            ld d,a
            ld (hl),d
            inc hl 
            ld a,(ix+0) ; x
            add a,Left
            ld (hl),a
            inc hl 
            ld (hl),e
            inc hl 
            ld a,e
            cp Char_MyFighter
            if nc
                ld a,(ix+0) ; x
                add a,Left+8
                if c
                    ld d,invaldY
                endif
                ld (hl),d ; y
                inc hl 
                ld (hl),a
                inc hl 
                inc e
                inc e
                ld (hl),e 
            else
                ld (hl),invaldY
            endif
        ei
	pop	de | pop hl | pop af
ret


HideSprite_:
    public HideSprite_
	push	af
	push	hl
	push	de
            ld l,a  ; index
            ld h,0
            ld e,l
            ld d,h
            add hl,hl   ;*2
            add hl,de   ;*3
            add hl,hl   ;*6
            ld de,Buffer
            add hl,de
            ld a,invaldY
            di
                ld (hl),a
                inc hl 
                inc hl 
                inc hl 
                ld (hl),a
            ei
    pop	de
	pop	hl
	pop	af
ret


HideAllSprites_:
    public HideAllSprites_
	push	hl
	push	bc
        ld hl,Buffer
        ld b,SpriteCount
        ld a,invaldY
        di
            do
                ld (hl),a
                inc hl
                inc hl
                inc hl
            dwnz
        ei
    pop	bc
	pop	hl
    call UpdateSprites_
ret


UpdateSprites_: public UpdateSprites_
    push af | push hl | push de | push bc
        ld de,VRAM_SpriteAttribute
        exx
            ld de,VRAM_SpriteAttribute+128
        exx
        di
            ld a,(FirstIndex)
            ld hl,(FirstAddress)
            ld b,SpriteCount
            do
                ex af,af'
                    ld a,(hl)
                    cp invaldY
                    if c
                        ld c,a
                        ld a,e | out (VdpPort+1),a
                        ld a,d | or 40h | out (VdpPort+1),a
                        inc de
                        ld a,c
                        out (VdpPort),a
                        inc hl
                        exx
                            ld a,e | out (VdpPort+1),a
                            ld a,d | or 40h | out (VdpPort+1),a
                            inc de | inc de
                        exx
                        ld a,(hl)
                        out (VdpPort),a
                        nop
                        inc hl
                        ld a,(hl)
                        inc hl
                        out (VdpPort),a
                    else
                        inc hl
                        inc hl
                        inc hl  
                    endif
                ex af,af'
                inc a
                cp SpriteCount
                if nc
                    xor a
                    ld hl,Buffer
                endif
            dwnz
            ld a,e | out (VdpPort+1),a
            ld a,d | or 40h | out (VdpPort+1),a
            ex af,af'
                ld a,0d0h
                out (VdpPort),a
            ex af,af'
        ei
        inc hl
        inc hl
        inc hl
        inc a
        cp SpriteCount
        if nc
            xor a
            ld hl,Buffer
        endif
        ld (FirstIndex),a
        ld (FirstAddress),hl
    pop bc | pop de | pop hl | pop af
ret
